/*

 Copyright 2013, 2014 SIANI - ULPGC
 Jose Juan Hernandez Cabrera
 Jose Evora Gomez
 Johan Sebastian Cortes Montenegro

 This File is Part of JavaFMI Project

 JavaFMI Project is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 JavaFMI Project is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with JavaFMI Library.  If not, see <http://www.gnu.org/licenses/>.

 */
package org.javafmi.kernel.modeldescription;

import org.javafmi.exceptions.ModelDescriptionException;
import org.simpleframework.xml.Serializer;
import org.simpleframework.xml.core.Persister;

import java.io.File;
import java.util.logging.Level;
import java.util.logging.Logger;

public class ModelDescriptionDeserializer {

    public static ModelDescription deserialize(Class<? extends ModelDescription> modelDescription, File modelDescriptionFile) {
        try {
            Serializer serializer = new Persister();
            return serializer.read(modelDescription, modelDescriptionFile);
        } catch (Exception ex) {
            Logger.getLogger(ModelDescriptionDeserializer.class.getName()).log(Level.SEVERE, null, ex);
            throw new ModelDescriptionException();
        }
    }
}
