/*

 Copyright 2013, 2014 SIANI - ULPGC
 Jose Juan Hernandez Cabrera
 Jose Evora Gomez
 Johan Sebastian Cortes Montenegro

 This File is Part of JavaFMI Project

 JavaFMI Project is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 JavaFMI Project is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with JavaFMI Library.  If not, see <http://www.gnu.org/licenses/>.

 */
package org.javafmi.kernel.operatingsystem;

import java.nio.ByteBuffer;
import java.nio.DoubleBuffer;
import java.nio.IntBuffer;

public class SharedMemoryAllocator {
    private IntBuffer valueReferenceBuffer;
    private DoubleBuffer bufferForDouble;
    private IntBuffer bufferForInt;
    private ByteBuffer bufferForByte;

    public SharedMemoryAllocator() {
        this.valueReferenceBuffer = IntBuffer.allocate(1);
        this.bufferForInt = IntBuffer.allocate(1);
        this.bufferForDouble = DoubleBuffer.allocate(1);
        this.bufferForByte = ByteBuffer.allocate(1);
    }

    public DoubleBuffer getSharedDouble() {
        return bufferForDouble;
    }

    public IntBuffer getSharedInteger() {
        return bufferForInt;
    }

    public ByteBuffer getSharedByte() {
        return bufferForByte;
    }

    public IntBuffer getSharedValueReference() {
        return valueReferenceBuffer;
    }

    public DoubleBuffer shareDoubles(int numberOfDoubles) {
        return DoubleBuffer.allocate(numberOfDoubles);
    }

    public ByteBuffer shareBytes(int numberOfBytes) {
        return ByteBuffer.allocate(numberOfBytes);
    }
}
