/*

 Copyright 2013, 2014 SIANI - ULPGC
 Jose Juan Hernandez Cabrera
 Jose Evora Gomez
 Johan Sebastian Cortes Montenegro
 Maria del Carmen Sánchez Medrano

 This File is Part of JavaFMI Project

 JavaFMI Project is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 JavaFMI Project is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with JavaFMI Library.  If not, see <http://www.gnu.org/licenses/>.

 */
 package org.javafmi.kernel.operatingsystem;

import java.io.File;

public class SystemUtils {

    public static void deleteAll(String fileName) {
        File file = new File(fileName);
        for(File subFile : file.listFiles()) {
            if(subFile.isDirectory()) deleteAll(subFile.getAbsolutePath());
            else subFile.delete();
        }
        file.delete();
    }

    public static boolean systemIsWin32() {
        return (getOSName().contains("Windows") && getOSArch().contains("x86"));
    }

    public static boolean systemIsWin64() {
        return (getOSName().contains("Windows") && getOSArch().contains("64"));
    }

    public static boolean systemIsLinux32() {
        return (getOSName().contains("Linux") && getOSArch().contains("86"));
    }

    public static boolean systemIsLinux64() {
        return (getOSName().contains("Linux") && getOSArch().contains("64"));
    }

    public static boolean systemIsMac32() {
        return (getOSName().contains("Mac") && getOSArch().contains("32"));
    }

    public static boolean systemIsMac64() {
        return (getOSName().contains("Mac") && getOSArch().contains("64"));
    }

    public static String getOSArch() {
        return System.getProperty("os.arch");
    }

    public static String getOSName() {
        return System.getProperty("os.name");
    }
}
